//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D2D931B02FA.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D2D931B02FA.cm

//## begin module%3D2D931B02FA.cp preserve=no
//## end module%3D2D931B02FA.cp

//## Module: MulTableComponent%3D2D931B02FA; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/MulTableComponent.cxx

//## begin module%3D2D931B02FA.additionalIncludes preserve=no
//## end module%3D2D931B02FA.additionalIncludes

//## begin module%3D2D931B02FA.includes preserve=yes
//## end module%3D2D931B02FA.includes

// TableComponent
#include <XSModel/Model/Component/TableComponent.h>
// ComponentBase
#include <XSModel/Model/Component/ComponentBase.h>
// MulTableComponent
#include <XSModel/Model/Component/MulTableComponent.h>


//## begin module%3D2D931B02FA.declarations preserve=no
//## end module%3D2D931B02FA.declarations

//## begin module%3D2D931B02FA.additionalDeclarations preserve=yes
#include <XSModel/Model/UniqueEnergy.h>
#include <XSUtil/Parse/XSparse.h>
#include "XSstreams.h"
#include <typeinfo>
//## end module%3D2D931B02FA.additionalDeclarations


// Class MulTableComponent 

MulTableComponent::MulTableComponent(const MulTableComponent &right)
  //## begin MulTableComponent::MulTableComponent%36C456E12958_copy.hasinit preserve=yes
      : MulComponent(right), 
        m_tableFile(right.m_tableFile), 
        m_tableType(right.m_tableType),
        m_table(0),
        m_expTable(right.m_expTable)
  //## end MulTableComponent::MulTableComponent%36C456E12958_copy.hasinit
  //## begin MulTableComponent::MulTableComponent%36C456E12958_copy.initialization preserve=yes
  //## end MulTableComponent::MulTableComponent%36C456E12958_copy.initialization
{
  //## begin MulTableComponent::MulTableComponent%36C456E12958_copy.body preserve=yes
   if (right.m_table) m_table = right.m_table->clone(this);
  //## end MulTableComponent::MulTableComponent%36C456E12958_copy.body
}

MulTableComponent::MulTableComponent (CGroupBase* p)
  //## begin MulTableComponent::MulTableComponent%37EFA5421138.hasinit preserve=yes
      : MulComponent(p), 
        m_tableFile(""), 
        m_tableType(""), 
        m_table(0),
        m_expTable(false)
  //## end MulTableComponent::MulTableComponent%37EFA5421138.hasinit
  //## begin MulTableComponent::MulTableComponent%37EFA5421138.initialization preserve=yes
  //## end MulTableComponent::MulTableComponent%37EFA5421138.initialization
{
  //## begin MulTableComponent::MulTableComponent%37EFA5421138.body preserve=yes
  //## end MulTableComponent::MulTableComponent%37EFA5421138.body
}


MulTableComponent::~MulTableComponent()
{
  //## begin MulTableComponent::~MulTableComponent%36C456E12958_dest.body preserve=yes
  delete m_table;
  //## end MulTableComponent::~MulTableComponent%36C456E12958_dest.body
}



//## Other Operations (implementation)
void MulTableComponent::calculate (bool saveComponentFlux, bool frozen)
{
  //## begin MulTableComponent::calculate%3767F03079B0.body preserve=yes
  if (saveComponentFlux) saveUniquePhotonArray(saveComponentFlux);
  
  
  const std::set<UniqueEnergy*>& energies = getUniqueEnergies();
  std::set<UniqueEnergy*>::const_iterator en   = energies.begin();
  std::set<UniqueEnergy*>::const_iterator enEnd = energies.end();
  // this flag is true for additive models - it means accumulate the
  // total flux in the energy bins as defined by uniqueEng. The converse
  // is where we want to "interpolate" the model, producing an array which
  // is scaled to the bin width - for multiplicative models.  
  const static bool interpolateSpectrum(false);
  while (en != enEnd)
  {
     const UniqueEnergy* uniqueEng = *en;
     const RealArray& energy = uniqueEng->energy();      
     uniquePhotonArray(uniqueEng).resize(energy.size()-1);
     if ( m_table->isError()) 
     {
             uniquePhotonErrArray(uniqueEng).resize(energy.size()-1);
             error(true);
     }


     m_table->interpolate(uniqueEng,uniquePhotonArray(uniqueEng),
                 uniquePhotonErrArray(uniqueEng),interpolateSpectrum, m_expTable);

     // output arrays if in debug mode (harmlessly returns if log chatter
     // is < 30)

     debugPrint(tcout,"\nModel Output AddTableComponent::calculate() -");
     ++en;

  }
  //## end MulTableComponent::calculate%3767F03079B0.body
}

int MulTableComponent::read ()
{
  //## begin MulTableComponent::read%374D98CBF3C5.body preserve=yes
    string modelName (Component::currentModelName());
    
    // set exponential table flag, used in calculate.    
    m_expTable = (modelName[0] == 'e');
    XSparse::returnDelimitedArgument(modelName," {");
    m_tableFile = XSparse::returnDelimitedArgument(modelName,"}");
    m_table = TableComponent::returnTable(m_tableFile);
    m_table->filename(m_tableFile);

    bool readNow(true);    
    m_table->read(readNow,this);
    name(m_table->name());
    const std::vector<Parameter*>& tableParams = m_table->parameters();
    componentBase()->parameterSet().reserve(tableParams.size());
    std::vector<Parameter*>::const_iterator p = tableParams.begin();
    std::vector<Parameter*>::const_iterator pEnd = tableParams.end();
    while ( p != pEnd )
    {
            (*p)->setParent(componentBase());
            (*p)->index(componentBase()->incrementModelParameterCount());
            parameterSet().push_back(*p);
            ++p;                     
    }
    componentBase()->numParams(tableParams.size());
    
    return 0;
  //## end MulTableComponent::read%374D98CBF3C5.body
}

void MulTableComponent::swap (Component& right)
{
  //## begin MulTableComponent::swap%376139C9B0C8.body preserve=yes
  Component::swap(right);
  MulTableComponent& that = static_cast<MulTableComponent&>(right);
  std::swap(m_tableFile,that.m_tableFile);
  std::swap(m_tableType,that.m_tableType);
  std::swap(m_table,that.m_table);    
  //## end MulTableComponent::swap%376139C9B0C8.body
}

MulTableComponent* MulTableComponent::clone (CGroupBase* p) const
{
  //## begin MulTableComponent::clone%38E3B62655F0.body preserve=yes
  MulTableComponent* cloned = new MulTableComponent(*this);
  cloned->setParent(p);
  return cloned;    
  //## end MulTableComponent::clone%38E3B62655F0.body
}

void MulTableComponent::copy (const Component& right)
{
  //## begin MulTableComponent::copy%3A953FA60366.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  MulTableComponent __temp(static_cast<const MulTableComponent&>(right));
  swap(__temp);   
  //## end MulTableComponent::copy%3A953FA60366.body
}

void MulTableComponent::clearArrays (const std::set<UniqueEnergy*>& currentEngs)
{
  //## begin MulTableComponent::clearArrays%3D7CF3770249.body preserve=yes
  Component::clearArrays(currentEngs);
  m_table->clearArrays(currentEngs);
  //## end MulTableComponent::clearArrays%3D7CF3770249.body
}

void MulTableComponent::initializeForFit ()
{
  //## begin MulTableComponent::initializeForFit%4593FF4300F6.body preserve=yes
   const std::set<UniqueEnergy*>& energies = getUniqueEnergies();
   std::set<UniqueEnergy*>::const_iterator itEng   = energies.begin();
   std::set<UniqueEnergy*>::const_iterator itEngEnd = energies.end();
   while (itEng != itEngEnd)
   {
      const UniqueEnergy* uniqueEng = *itEng;
      m_table->energyWeights(uniqueEng);
      ++itEng;
   }
  //## end MulTableComponent::initializeForFit%4593FF4300F6.body
}

// Additional Declarations
  //## begin MulTableComponent%36C456E12958.declarations preserve=yes
  //## end MulTableComponent%36C456E12958.declarations

//## begin module%3D2D931B02FA.epilog preserve=yes
//## end module%3D2D931B02FA.epilog
